import os
import socket
import sys

import runloop

def receive(fd, answer):
    data = os.read(fd, 1024)
    os.close(fd)
    del runloop.reading[fd]
    os.wait()
    if data:
        if data[0] == 'A':
            answer.answer(data[1:])
        elif data[0] == 'E':
            answer.error(data[1:])

def gethostbyname(name, answer):
    pipe_read, pipe_write = os.pipe()
    pid = os.fork()
    if pid:
        os.close(pipe_write)
        runloop.reading[pipe_read] = lambda fd, answer=answer: receive(fd, answer)
    else:
        os.close(pipe_read)
        try:
            data = 'A' + socket.gethostbyname(name)
        except socket.error, msg:
            data = 'E' + str(msg)
        os.write(pipe_write, data)
        os.close(pipe_write)
        os._exit(0)

## End. ##
